require "config"

local function adjust_energy(value)
	start, stop = string.find(value, "[0123456789.]+")
	new_value = tonumber(string.sub(value, start, stop))
	new_value = new_value * gtts_time_scale
	return tostring(new_value)..string.sub(value, stop + 1, string.len(value))
end


local function adjust_speeds()
	for _, prototype_type in pairs(data.raw) do
		for prototype_name, prototype in pairs(prototype_type) do

			for _,speed in ipairs(prototype_speeds) do
				if prototype[speed] then
					prototype[speed] = prototype[speed] * gtts_time_scale
				end
			end

			for _,rate in ipairs(prototype_power_rates) do
				if prototype[rate] then
					prototype[rate] = adjust_energy(prototype[rate])
				end
			end

			for _,duration in ipairs(prototype_durations) do
				if prototype[duration] then
					prototype[duration] = prototype[duration] / gtts_time_scale
				end
			end

			if prototype["attack_parameters"] then
				if prototype["attack_parameters"]["cooldown"] then
					prototype["attack_parameters"]["cooldown"] = prototype["attack_parameters"]["cooldown"] / gtts_time_scale
				end
				if prototype["attack_parameters"]["warmup"] then
					prototype["attack_parameters"]["warmup"] = prototype["attack_parameters"]["warmup"] / gtts_time_scale
				end
				if      prototype["attack_parameters"]["ammo_type"] 
					and prototype["attack_parameters"]["ammo_type"]["action"]
					and prototype["attack_parameters"]["ammo_type"]["action"]["action_delivery"]
					and prototype["attack_parameters"]["ammo_type"]["action"]["action_delivery"]["starting_speed"] then
					
					prototype["attack_parameters"]["ammo_type"]["action"]["action_delivery"]["starting_speed"] = prototype["attack_parameters"]["ammo_type"]["action"]["action_delivery"]["starting_speed"] * gtts_time_scale
				end
			end

			if prototype["ammo_type"] and prototype["ammo_type"]["action"] and prototype["ammo_type"]["action"]["action_delivery"] and prototype["ammo_type"]["action"]["action_delivery"]["starting_speed"] then
				prototype["ammo_type"]["action"]["action_delivery"]["starting_speed"] = prototype["ammo_type"]["action"]["action_delivery"]["starting_speed"] * gtts_time_scale
			end

			if prototype["energy_source"] and prototype["energy_source"]["drain"] then
				prototype["energy_source"]["drain"] = adjust_energy(prototype["energy_source"]["drain"])
			end

			if prototype["spawning_cooldown"] then
				for i = 1, #prototype["spawning_cooldown"] do
					prototype["spawning_cooldown"][i] = prototype["spawning_cooldown"][i] / gtts_time_scale
				end
			end

			if prototype["damage_per_tick"] and prototype["damage_per_tick"]["ammount"] then
				prototype["damage_per_tick"]["ammount"] = prototype["damage_per_tick"]["ammount"] * gtts_time_scale
			end
			
			if prototype["animation"] and prototype["animation"]["filename"] then
				if prototype["animation"]["animation_speed"] then
					prototype["animation"]["animation_speed"] = prototype["animation"]["animation_speed"] * gtts_time_scale
					if prototype["animation"]["hr_version"] then
						prototype["animation"]["hr_version"]["animation_speed"] = prototype["animation"]["hr_version"]["animation_speed"] * gtts_time_scale
					end
				else
					prototype["animation"]["animation_speed"] = gtts_time_scale
					if prototype["animation"]["hr_version"] then
						prototype["animation"]["hr_version"]["animation_speed"] = gtts_time_scale
					end
				end
			end
			
			if prototype["shell_particle"] then
				if prototype["shell_particle"]["speed"] then
					prototype["shell_particle"]["speed"] = prototype["shell_particle"]["speed"] * gtts_time_scale
				end
				if prototype["shell_particle"]["speed_deviation"] then
					prototype["shell_particle"]["speed_deviation"] = prototype["shell_particle"]["speed_deviation"] * gtts_time_scale
				end
				if prototype["shell_particle"]["starting_frame_speed"] then
					prototype["shell_particle"]["starting_frame_speed"] = prototype["shell_particle"]["starting_frame_speed"] * gtts_time_scale
				end
				if prototype["shell_particle"]["starting_frame_speed_deviation"] then
					prototype["shell_particle"]["starting_frame_speed_deviation"] = prototype["shell_particle"]["starting_frame_speed_deviation"] * gtts_time_scale
				end
			end

			if prototype["attack_parameters"] and prototype["attack_parameters"]["animation"] and prototype["attack_parameters"]["animation"]["filename"] then
				if prototype["attack_parameters"]["animation"]["animation_speed"] then
					prototype["attack_parameters"]["animation"]["animation_speed"] = prototype["attack_parameters"]["animation"]["animation_speed"] * gtts_time_scale
					if prototype["attack_parameters"]["animation"]["hr_version"] then
						prototype["attack_parameters"]["animation"]["hr_version"]["animation_speed"] = prototype["attack_parameters"]["animation"]["hr_version"]["animation_speed"] * gtts_time_scale
					end
				else
					prototype["attack_parameters"]["animation"]["animation_speed"] = gtts_time_scale
					if prototype["attack_parameters"]["animation"]["hr_version"] then
						prototype["attack_parameters"]["animation"]["hr_version"]["animation_speed"] = gtts_time_scale
					end
				end
			end
		end
	end
end


adjust_speeds()
